import { Button, Result } from "@arco-design/web-react";
import { useEffect } from "react";
import { useLocation } from "react-router-dom";
import Cookies from "js-cookie";

interface IGuardProps {
  children: JSX.Element;
}

const needAuthList = ["course/detail"];

export const Guard = (props: IGuardProps) => {
  const location = useLocation();
  const sessionExist = !!Cookies.get("_session");
  const needAuth = needAuthList.some((p) => location.pathname.indexOf(p) > -1);

  useEffect(() => {
    console.log("location.pathname changed 拦截", location.pathname);
    if (location.pathname.indexOf("course/detail/") > -1) {
      console.log("进入课程详情页");
    }
  }, [location.pathname]);

  if (needAuth && !sessionExist)
    return (
      <div style={{ paddingTop: 100 }}>
        <Result status="403" subTitle="无权访问，请登录" />
      </div>
    );
  return props.children;
};
